# Yahoo! UI Library

### Charts Widget 2.9.0

Yahoo! UI Library > charts > YAHOO.widget.Chart
Search:
Filters Show Private Show Protected Show Deprecated

## Class YAHOO.widget.Chart - uses YAHOO.util.AttributeProvider

Chart class for the YUI Charts widget.

### Constructor

YAHOO.widget.Chart `( type , containerId , dataSource , attributes )`

Parameters:
  `type <String>` The char type. May be "line", "column", "bar", or "pie"
  `containerId <HTMLElement>` Container element for the Flash Player instance.
  `dataSource <YAHOO.util.DataSource>` DataSource instance.
  `attributes <object>` (optional) Object literal of configuration values.

### Properties

#### _attributes - `private Object`

The initializing attributes are stored here until the SWF is ready.

#### _containerID - `private String`

The ID of the containing DIV.

#### _dataSource - `private object`

Storage for the dataSource attribute.

#### _dataTipFunction - `private String`

Stores a reference to the dataTipFunction created by YAHOO.widget.Chart.createProxyFunction()

#### _id - `private String`

The id of this instance.

#### _initialized - `private Boolean`

Indicates whether the SWF has been initialized and is ready to communicate with JavaScript

#### _legendLabelFunction - `private String`

Stores a reference to the legendLabelFunction created by YAHOO.widget.Chart.createProxyFunction()

#### _pollingID - `private Number`

The id returned from the DataSource's setInterval function.

#### _pollingInterval - `private Number`

The time, in ms, between requests for data.

#### _request - `private object`

Storage for the request attribute.

#### _seriesDefs - `private object`

Storage for the series attribute.

#### _seriesFunctions - `private Array`

Stores references to series function values created by YAHOO.widget.Chart.createProxyFunction()

#### _swf - `private object`

A reference to the embedded SWF file.

#### _swfEmbed - `private swf`

The javascript wrapper for the swf object

#### _swfURL - `private String`

The URL of the SWF file.

#### _type - `private String`

The type of this chart instance.

#### Chart.SWFURL - `private static final object`

Storage for the dataTipFunction attribute.
Default Value: "assets/charts.swf"

#### proxyFunctionCount - `private static object`

The number of proxy functions that have been created.

#### Properties inherited from YAHOO.util.AttributeProvider:

`_configs`

#### Properties inherited from YAHOO.util.EventProvider:

`__yui_events, __yui_subscribers`

### Methods

#### _eventHandler

`private void _eventHandler ( )`
Handles swfReady event from SWF.

#### _getAltText

`private void _getAltText ( )`
Getter for altText attribute.

#### _getCategoryNames

`private void _getCategoryNames ( )`
Getter for the categoryNames attribute.

#### _getDataSource

`private void _getDataSource ( )`
Getter for the dataSource attribute.

#### _getLegendLabelFunction

`private void _getLegendLabelFunction ( )`
Getter for the legendLabelFunction attribute.

#### _getPolling

`private void _getPolling ( )`
Getter for the polling attribute.

#### _getRequest

`private void _getRequest ( )`
Getter for the request attribute.

#### _getSeriesDefs

`private void _getSeriesDefs ( )`
Getter for the series attribute.

#### _getSWFURL

`private void _getSWFURL ( )`
Getter for swfURL attribute.

#### _initAttributes

`private void _initAttributes ( )`
Initializes the attributes.

#### _loadDataHandler

`private void _loadDataHandler ( )`
Called when the DataSource receives new data. The series definitions are used to build a data provider for the SWF chart.

#### _loadHandler

`private void _loadHandler ( )`
Called when the SWF is ready for communication. Sets the type, initializes the styles, and sets the DataSource.

#### _setAltText

`private void _setAltText ( )`
Setter for altText attribute.

#### _setCategoryNames

`private void _setCategoryNames ( )`
Setter for the categoryNames attribute.

#### _setDataSource

`private void _setDataSource ( )`
Setter for the dataSource attribute.

#### _setDataTipFunction

`private void _setDataTipFunction ( )`
Setter for the dataTipFunction attribute.

#### _setLegendLabelFunction

`private void _setLegendLabelFunction ( )`
Setter for the legendLabelFunction attribute.

#### _setPolling

`private void _setPolling ( )`
Setter for the polling attribute.

#### _setRequest

`private void _setRequest ( )`
Setter for the request attribute.

#### _setSeriesDefs

`private void _setSeriesDefs ( )`
Setter for the series attribute.

#### refreshData

`void refreshData ( )`
Sends (or resends) the request to the DataSource.

#### setSeriesStyles

`void setSeriesStyles ( styles )`
Sets the styles on all series in the Chart.

Parameters:
  `styles <Array>` Initializer for all Chart series styles.

#### setStyle

`void setStyle ( name , value )`
Sets a single style value on the Chart instance.

Parameters:
  `name <String>` Name of the Chart style value to change.
  `value <Object>` New value to pass to the Chart style.

#### setStyles

`void setStyles ( styles )`
Resets all styles on the Chart instance.

Parameters:
  `styles <Object>` Initializer for all Chart styles.

#### toString

`String toString ( )`
Public accessor to the unique name of the Chart instance.

Returns: `String`
  Unique name of the Chart instance.

#### YAHOO.widget.Chart.createProxyFunction

`private static void YAHOO.widget.Chart.createProxyFunction ( )`
Creates a globally accessible function that wraps a function reference. Returns the proxy function's name as a string for use by the SWF through ExternalInterface.

#### YAHOO.widget.Chart.getFunctionReference

`private static void YAHOO.widget.Chart.getFunctionReference ( )`
Uses YAHOO.widget.Chart.createProxyFunction to return string reference to a function.

#### YAHOO.widget.Chart.removeProxyFunction

`private static void YAHOO.widget.Chart.removeProxyFunction ( )`
Removes a function created with createProxyFunction()

#### Methods inherited from YAHOO.util.AttributeProvider:

`configureAttribute, fireBeforeChangeEvent, fireChangeEvent, get, getAttributeConfig, getAttributeKeys, refresh, register, resetAttributeConfig, resetValue, set, setAttributeConfig, setAttributes`

#### Methods inherited from YAHOO.util.EventProvider:

`createEvent, fireEvent, hasEvent, subscribe, unsubscribe, unsubscribeAll`

### Events

#### altTextChange

`altTextChange ( event )`
Fires when the value for the configuration attribute 'altText' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### backgroundColorChange

`backgroundColorChange ( event )`
Fires when the value for the configuration attribute 'backgroundColor' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeAltTextChange

`beforeAltTextChange ( event )`
Fires before the value for the configuration attribute 'altText' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeBackgroundColorChange

`beforeBackgroundColorChange ( event )`
Fires before the value for the configuration attribute 'backgroundColor' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeCategoryNamesChange

`beforeCategoryNamesChange ( event )`
Fires before the value for the configuration attribute 'categoryNames' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeDataSourceChange

`beforeDataSourceChange ( event )`
Fires before the value for the configuration attribute 'dataSource' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeDataTipFunctionChange

`beforeDataTipFunctionChange ( event )`
Fires before the value for the configuration attribute 'dataTipFunction' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeExpressInstallChange

`beforeExpressInstallChange ( event )`
Fires before the value for the configuration attribute 'expressInstall' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeLegendLabelFunctionChange

`beforeLegendLabelFunctionChange ( event )`
Fires before the value for the configuration attribute 'legendLabelFunction' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforePollingChange

`beforePollingChange ( event )`
Fires before the value for the configuration attribute 'polling' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeRequestChange

`beforeRequestChange ( event )`
Fires before the value for the configuration attribute 'request' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeSeriesChange

`beforeSeriesChange ( event )`
Fires before the value for the configuration attribute 'series' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeSwfURLChange

`beforeSwfURLChange ( event )`
Fires before the value for the configuration attribute 'swfURL' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeVersionChange

`beforeVersionChange ( event )`
Fires before the value for the configuration attribute 'version' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### beforeWmodeChange

`beforeWmodeChange ( event )`
Fires before the value for the configuration attribute 'wmode' changes. Return false to cancel the attribute change.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### categoryNamesChange

`categoryNamesChange ( event )`
Fires when the value for the configuration attribute 'categoryNames' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### contentReady

`contentReady ( )`
Fires when the SWF is initialized and communication is possible.

#### dataSourceChange

`dataSourceChange ( event )`
Fires when the value for the configuration attribute 'dataSource' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### dataTipFunctionChange

`dataTipFunctionChange ( event )`
Fires when the value for the configuration attribute 'dataTipFunction' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### expressInstallChange

`expressInstallChange ( event )`
Fires when the value for the configuration attribute 'expressInstall' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### itemClickEvent

`itemClickEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user clicks an item renderer in the chart with the mouse.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemDoubleClickEvent

`itemDoubleClickEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user double-clicks an item renderer in the chart with the mouse.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemDragEndEvent

`itemDragEndEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user releases the mouse during a drag action.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemDragEvent

`itemDragEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user moves the mouse during a drag action.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemDragStartEvent

`itemDragStartEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user presses the mouse down on an item to initiate a drag action.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemMouseOutEvent

`itemMouseOutEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user moves the mouse out of the bounds of an item renderer in the chart.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### itemMouseOverEvent

`itemMouseOverEvent ( event.type , event.item , event.index , event.seriesIndex , event.x , event.y )`
Fires when the user moves the mouse over the bounds of an item renderer in the chart.

Parameters:
  `event.type <String>` The event type
  `event.item <Object>` The data displayed by the renderer
  `event.index <Number>` The position within the series that the item appears.
  `event.seriesIndex <Number>` The position within the series definition that the series appears.
  `event.x <Number>` The horizontal position of the mouse, relative to the SWF.
  `event.y <Number>` The vertical position of the mouse, relative to the SWF.

#### legendLabelFunctionChange

`legendLabelFunctionChange ( event )`
Fires when the value for the configuration attribute 'legendLabelFunction' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### pollingChange

`pollingChange ( event )`
Fires when the value for the configuration attribute 'polling' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### requestChange

`requestChange ( event )`
Fires when the value for the configuration attribute 'request' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### seriesChange

`seriesChange ( event )`
Fires when the value for the configuration attribute 'series' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### swfURLChange

`swfURLChange ( event )`
Fires when the value for the configuration attribute 'swfURL' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### versionChange

`versionChange ( event )`
Fires when the value for the configuration attribute 'version' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

#### wmodeChange

`wmodeChange ( event )`
Fires when the value for the configuration attribute 'wmode' changes.

Parameters:
  `event <{oldValue: any, newValue: any}>` An object containing the previous attribute value and the new value.

### Configuration Attributes

#### altText `- String`

The alternative text to provide for screen readers and other assistive technology.

#### backgroundColor `- String`

The background color of the SWF. Only available in the constructor because it may not be set after Flash Player has been embedded in the page.

#### categoryNames `- Array`

Defines the names of the categories to be displayed in the Chart..

#### dataSource `- DataSource`

The DataSource instance to display in the Chart.

#### dataTipFunction `- String`

The string representation of a globally-accessible function that may be called by the SWF to generate the datatip text for a Chart's item.

#### expressInstall `- String`

URL pointing to a SWF file that handles Flash Player's express install feature. Only available in the constructor because it may not be set after Flash Player has been embedded in the page.

#### legendLabelFunction `- String`

The string representation of a globally-accessible function that may be called by the SWF to format the labels of a Chart's legend.

#### polling `- Number`

A numeric value indicating the number of milliseconds between polling requests to the DataSource.

#### request `- String`

Request to be sent to the Chart's DataSource.

#### series `- Array`

Defines the series to be displayed by the Chart.

#### swfURL `- String`

Absolute or relative URL to the SWF displayed by the Chart. Only available in the constructor because it may not be set after Flash Player has been embedded in the page.

#### version `- String`

Minimum required version for the SWF file. Only available in the constructor because it may not be set after Flash Player has been embedded in the page.

#### wmode `- String`

Sets the window mode of the Flash Player control. May be "window", "opaque", or "transparent". Only available in the constructor because it may not be set after Flash Player has been embedded in the page.

Copyright © 2011 Yahoo! Inc. All rights reserved.